#include <SPI.h>
#include <nRF24L01p.h>

#define UP PIN_PC4
#define RIGHT PIN_PC3
#define DOWN PIN_PC0
#define LEFT PIN_PC2
#define CONNECT PIN_PC1
#define CSN PIN_PB0
#define CE PIN_PB1
#define LED PIN_PB2

nRF24L01p transmitter(CSN, CE);

long lastDebounceTime = 0;
long debounceDelay = 50;
int buttonState;
int lastButtonState = HIGH;
int state = HIGH;

void chk_state() {
  int reading = digitalRead(CONNECT);

  if (reading != lastButtonState)
    lastDebounceTime = millis();

  if ((millis() - lastDebounceTime) > debounceDelay) {
    if (reading != buttonState) {
      buttonState = reading;

      if (buttonState == HIGH)
        state = !state;
    }
  }
  lastButtonState = reading;
}

void setup() {
  delay(150);
  Serial.begin(115200);
  SPI.begin();
  SPI.setBitOrder(MSBFIRST);
  transmitter.channel(90);
  transmitter.TXaddress("MOO");
  transmitter.init();
  pinMode(UP, INPUT_PULLUP);
  pinMode(DOWN, INPUT_PULLUP);
  pinMode(LEFT, INPUT_PULLUP);
  pinMode(RIGHT, INPUT_PULLUP);
  pinMode(CONNECT, INPUT_PULLUP);
  pinMode(LED, OUTPUT);
}

void loop() {
  int a[5];
  a[4] = HIGH;
  a[0] = digitalRead(UP);
  a[1] = digitalRead(DOWN);
  a[2] = digitalRead(LEFT);
  a[3] = digitalRead(RIGHT);

  chk_state();
  a[4] = state;
  digitalWrite(LED, a[4]);
  Serial.println(a[4]);
  transmitter.txPL(a, 5);
  transmitter.send(SLOW);
}
